//importing the required  functions from the D3 library
import { csv, select } from 'd3';

//importing the scatterPlot function from the scatterPlot.js file
import { scatterPlot } from './scatterPlot';

//  URL of my iris dataset
const csvUrl = [
  'https://gist.githubusercontent.com/',
  'prachow/', // User
  'f55786dcf9a37c35576d59d3a5d4c808/', // Id of the Gist
  'raw/0ace8c5ab9e06559fd67c17c492d6153aa34d09b/', // commit
  'iris.csv', // File name
].join('');

//  function used to parse each row of the loaded csv file
const parseRow = (d) => {
  d.sepal_length = +d.sepal_length;
  d.sepal_width = +d.sepal_width;
  d.petal_length = +d.petal_length;
  d.petal_width = +d.petal_width;
  return d;
};

// To set width and height of the svg element to the size of the window
const width = window.innerWidth;
const height = window.innerHeight;
const svg = select('body')
  .append('svg')
  .attr('width', width)
  .attr('height', height);

//  function which loads the csv data and creates the scatter plot
const main = async () => {
  
  //invoking svg elements
  svg.call(
    
    // The scatter plot using the scatterPlot function and the csv data
    scatterPlot()
      .width(width)
      .height(height)
      .data(await csv(csvUrl, parseRow))
      .xValue((d) => d.petal_width)
      .yValue((d) => d.sepal_length)
      .symbolValue((d) => d.species)
      .margin({
        top: 20,
        right: 30,
        bottom: 150,
        left: 20,
      })
      .size(100)
  );
};
// calls the main function
main();
